VERSION 5.00
Begin VB.Form frmPrint 
   Caption         =   "Print Example"
   ClientHeight    =   2040
   ClientLeft      =   3570
   ClientTop       =   4410
   ClientWidth     =   6180
   LinkTopic       =   "Form1"
   ScaleHeight     =   2040
   ScaleWidth      =   6180
   Begin VB.CommandButton cdCancel 
      Caption         =   "Exit"
      Height          =   400
      Index           =   0
      Left            =   4035
      TabIndex        =   2
      Top             =   750
      Width           =   1500
   End
   Begin VB.CommandButton cdPreview 
      Caption         =   "Preview"
      Height          =   400
      Index           =   1
      Left            =   2355
      TabIndex        =   1
      Top             =   750
      Width           =   1500
   End
   Begin VB.CommandButton cdPrint 
      Caption         =   "Print"
      Height          =   400
      Index           =   0
      Left            =   660
      TabIndex        =   0
      Top             =   750
      Width           =   1500
   End
End
Attribute VB_Name = "frmPrint"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function CreateDC Lib "gdi32" Alias "CreateDCA" (ByVal lpDriverName As String, ByVal lpDeviceName As String, ByVal lpOutput As Long, ByVal lpInitData As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function GetDeviceCaps Lib "gdi32" (ByVal hDC As Long, ByVal nIndex As Long) As Long

' Constants for nIndex argument of GetDeviceCaps
Private Const LOGPIXELSX = 88
Private Const LOGPIXELSY = 90
Private Const PHYSICALWIDTH = 110
Private Const PHYSICALHEIGHT = 111
Private Const TOTALSPACE_HORIZONTAL = 6
Private Const TOTALSPACE_VERTICAL = 7

Private Const IERR_PAPERTOOSMALL = 1000
Private Const SERR_PAPERTOOSMALL = "The paper size is too small. Minimum paper size is 4x4 in. (102x102 mm). Please set a larger paper size for the default printer."

Private Const INCH_TWIPS = 1440

Private Sub cdCancel_Click(Index As Integer)
    Unload Me
End Sub

Private Sub cdPreview_Click(Index As Integer)
    If RptBuild Then
        rptExample.Show vbModal, Screen.ActiveForm
    End If
    Unload rptExample
End Sub

Private Sub cdPrint_Click(Index As Integer)
    If RptBuild Then
        rptExample.PrintReport False
    End If
    Unload rptExample
End Sub

Private Function RptBuild()
    Dim vReportWidth, vReportHeight, vPaperWidth, vPaperHeight

    On Error GoTo ERRORHANDLER

    With rptExample
        ' Get the paper size for the default printer
        vPaperWidth = GetPrinterDim(.Printer.DeviceName, TOTALSPACE_HORIZONTAL)
        vPaperHeight = GetPrinterDim(.Printer.DeviceName, TOTALSPACE_VERTICAL)

        ' Check the paper size, must be bigger than minimum allowed (4 x 4 inch)
        If vPaperWidth < 4 * INCH_TWIPS Or vPaperHeight < 4 * INCH_TWIPS Then
            Err.Raise IERR_PAPERTOOSMALL, App.EXEName, SERR_PAPERTOOSMALL
        End If

        ' Calculate the report width and height
        vReportWidth = vPaperWidth - 2 * INCH_TWIPS
        vReportHeight = vPaperHeight - 2 * INCH_TWIPS

        ' Set the report width
        .PrintWidth = vReportWidth

        ' If custom paper size selected, set it to PageSettings
        If .Printer.PaperSize = 256 Then
            .PageSettings.PaperSize = 256
            .PageSettings.PaperWidth = vPaperWidth
            .PageSettings.PaperHeight = vPaperHeight
        End If

        ' Set the margins
        With .PageSettings
            .LeftMargin = INCH_TWIPS
            .RightMargin = INCH_TWIPS
            .TopMargin = INCH_TWIPS
            .BottomMargin = INCH_TWIPS
        End With

        ' Resize the report controls and sections
        .Sections("Detail").Controls("lbTitle").Width = vReportWidth
        .Sections("Detail").Controls("lbTitle").Height = vReportHeight
        .Sections("Detail").Height = vReportHeight
    End With

    RptBuild = True
    Exit Function

ERRORHANDLER:
    MsgBox Err.Description, vbInformation, App.Title
    RptBuild = False
End Function

'-------------------------------------------------------------------------------
' Function to get the printer page size in twips
' I: sPrinter       printer name
' I: vType          TOTALSPACE_HORIZONTAL, TOTALSPACE_VERTICAL
'-------------------------------------------------------------------------------
Private Function GetPrinterDim(sPrinter As String, vType)
    Dim lDpi As Long, lDim As Long, hPrinterDC As Long

    hPrinterDC = CreateDC(sPrinter, sPrinter, 0, 0)
    If hPrinterDC = 0 Then
        GetPrinterDim = 0
    Else
        ' Pixels
        Select Case vType
        Case TOTALSPACE_VERTICAL
            lDpi = GetDeviceCaps(hPrinterDC, LOGPIXELSY)
        Case Else
            lDpi = GetDeviceCaps(hPrinterDC, LOGPIXELSX)
        End Select
          
        ' Avoid divide/0
        If lDpi = 0 Then
            GetPrinterDim = 0
        Else
            Select Case vType
            Case TOTALSPACE_HORIZONTAL
                ' Total space horizontal in pixels
                lDim = GetDeviceCaps(hPrinterDC, PHYSICALWIDTH)
            
            Case TOTALSPACE_VERTICAL
                ' Total space vertical in pixels
                lDim = GetDeviceCaps(hPrinterDC, PHYSICALHEIGHT)
            End Select
            GetPrinterDim = lDim * INCH_TWIPS / lDpi
        End If
        
        DeleteDC hPrinterDC
    End If
End Function
